module Netfira::WebConnect
  class Model < ActiveRecord::Base
    class Record < self
      class FileRecord < self
      end
      class Translation < Model
      end
    end
    class Relation < self
    end
    class Support < self
    end

    class << self
      def table_name
        Models::Table.table_name
      end

      def single_name
        @single_name ||= name.demodulize.underscore.freeze
      end

      def plural_name
        @plural_name ||= single_name.pluralize.freeze
      end
    end

    def dispatch_event(*args, &block)
      Netfira::WebConnect.dispatch_event *args, &block
    end

  end
end

require_relative 'model/record'
require_relative 'model/relation'
require_relative 'model/support'
