module Netfira::WebConnect
  class Model::Record

    module Digests
      extend ActiveSupport::Concern

      included do
        before_save :write_digest
      end

      def digest
        changed? ? Checksum.of(to_s) : Checksum.new(self[:digest])
      end

      private

      def write_digest
        self.digest = digest.b
      end

    end

  end
end
