require 'ostruct'
require 'fastimage'

module Netfira::WebConnect
  class Models::Image < Model::Record::FileRecord

    def focus_point=(point)
      self.focus_point_top = point[:top]
      self.focus_point_left = point[:left]
      self.focus_point
    end

    def focus_point
      @focus_point ||= FocusPoint.new(self)
    end

    def data=(value)
      super value
      self.width, self.height = FastImage.size(attachment.staged_path)
    end

    def dimensions
      [width, height]
    end

    def dimensions=(value)
      self.width, self.height = value
    end

    class FocusPoint

      def initialize(image)
        @image = image
      end

      %w[top left].each do |attr|
        define_method :"#{attr}" do
          @image[:"focus_point_#{attr}"]
        end
        define_method :"#{attr}=" do |value|
          @image[:"focus_point_#{attr}"] = value
        end
      end

    end

  end
end
