require 'securerandom'

module Netfira::WebConnect
  class Models::Session < Model::Support

    belongs_to :shop

    after_initialize :generate_token

    def self.by_token(token)
      where(token: token).where(expires_at_column.eq(nil).or expires_at_column.gt(Time.now)).first
    end

    private

    def generate_token
      self.token ||= SecureRandom.random_bytes(20).unpack('H*').first
    end

    def self.expires_at_column
      @expires_at_column ||= arel_table[:expires_at]
    end

  end
end
