module Netfira::WebConnect
  class RackApp::Action

    def class_for_record_type(type)
      class_for_type type, Model::Record
    end

    def class_for_relation_type(type)
      class_for_type type, Model::Relation
    end

    private

    def class_for_type(type, superclass)
      raise BadRequest, 'No data type specified' if type.nil?
      klass = Models.const_defined?(type) && Models.const_get(type)
      raise BadRequest, 'Invalid or unknown data type' unless klass && klass < superclass
      klass
    end

  end
end
