class Netfira::WebConnect::RackApp
  module Action::Version1
    class Info < Action
      def call
        brokers = []
        brokers << {uri: Netfira::WebConnect.amqp_uri, queues: [shop.amqp_queue]} if Netfira::WebConnect.amqp_uri
        {
            info: {
                apiVersion: Action.latest_version,
                libVersion: Netfira::WebConnect::VERSION,
                schema: Netfira::WebConnect.schema,
                customFields: false,
                acceptableRequestTypes: env['WC_ACCEPTABLE_REQUEST_TYPES'] || ['unpacked'],
                locale: shop.locale,
                messageBrokers: brokers
            }
        }
      end
    end
  end
end
