class Netfira::WebConnect::RackApp
  module Action::Version8
    class Commit < Action

      def call
        allow :put, Hash
        dispatch_event :before, :commit, shop
        dispatch_event :around, :commit, shop do
          commit_records input['records'] if input['records']
          commit_relations input['relations'] if input['relations']
          [completed(:records), completed(:relations)]
        end
        dispatch_event [:on, :after], :commit, shop, completed(:records), completed(:relations)
        {
            complete: complete,
            filesToSend: files_to_send
        }
      end

      private

      def files_to_send
        @files_to_send ||= {}
      end

      def complete
        @complete ||= {
            records: {},
            relations: {}
        }
      end

      def completed(type)
        (@completed ||= {})[type] ||= Netfira::WebConnect::HashOfModels.new
      end

    end
  end
end

require_relative 'commit/records'
require_relative 'commit/relations'
