class Netfira::WebConnect::RackApp
  module Action::Version8
    class Commit < Action

      private

      def commit_relations(relations)
        relations.each do |class_name, relation_sets|
          klass = class_for_relation_type class_name.sub('&', 'To')
          relation_sets.each do |relation|
            relation_model = update_relation(klass, relation)
            complete_relation class_name, relation, relation_model
          end
        end
      end

      def update_relation(klass, relation)

        # Make a hash of models => IDs, e.g. {Product => '123', Image => 'file.jpg'}
        origin_ids = [relation['a'], relation['b']].each_with_index.map do |origin_id, index|
          [klass.related_classes[index], origin_id]
        end.to_h

        if relation['x']
          relate_records origin_ids
        else
          unrelate_records origin_ids
        end
      end

      def relate_records(origin_ids)
        records = origin_ids.map{ |k, id| k.find_or_create_by_origin_id shop, id }
        records[0] << records[1]
      end

      def unrelate_records(origin_ids)
        records = origin_ids.map{ |k, id| k.find_by_origin_id shop, id }.reject(&:nil?)
        records[0].unrelate records[1] if records.size == 2
      end

      def complete_relation(class_name, relation, relation_model)
        completed(:relations) << relation_model if relation_model
        list = complete[:relations][class_name] ||= []
        list << relation
      end

    end
  end
end
