module Netfira::WebConnect
  class RackApp
    module Action::Version8
      class Confirm < Action

        def call
          allow :put, Hash
          self.class.types.each do |type, klass|
            ids = input[type]
            ids.each { |guid| confirm_delivery klass, guid if %r`^[\w+/]{22}$` === guid } if Array === ids
          end
          {}
        end

        private

        def confirm_delivery(klass, guid)
          record = klass.find_by(shop_id: shop.id, guid: Guid.from_base64(guid).b)
          if record
            record.delivered!
            record.save!
          end
        end

        def self.types
          @types ||= Model::Record.sendable.map { |k| [k.plural_name.camelize(:lower), k] }.to_h
        end

      end
    end
  end
end
