class Netfira::WebConnect::RackApp
  module Action::Version8

    class_methods = Module.new do

      def record_class
        @record_class ||= Netfira::WebConnect::Models.const_get self::MODEL_NAME
      end

      def collection_name
        @collection_name ||= self::MODEL_NAME.pluralize.downcase.freeze
      end

    end

    fetch_class = Class.new Action do
      extend class_methods

      def call
        allow :get
        {self.class.collection_name => undelivered.map(&:to_deprecated_downstream)}
      end

      private

      def undelivered
        self.class.record_class.sent_and_undelivered.where(shop_id: shop.id)
      end

    end

    confirm_class = Class.new Action do
      extend class_methods

      def call
        allow :put
        record = self.class.record_class.sent_and_undelivered.find_by(shop_id: shop.id, id: query_string['id'])
        if record
          record.delivered!
          record.save
        end
        {}
      end

    end

    # There will be more classes later, e.g. Documents. When they are needed, they can
    # be added to the array below.
    %w(Order).each do |name|
      const_set :"New#{name.pluralize}", Class.new(fetch_class  ).tap { |c| c::MODEL_NAME = name.freeze }
      const_set :"Confirm#{name}",       Class.new(confirm_class).tap { |c| c::MODEL_NAME = name.freeze }
    end

  end
end
