module Netfira::WebConnect
  class RackApp
    module Action::Version8
      class Fetch < Action

        def call
          allow :get
          self.class.types.map { |type, klass| [type, records_for_class(klass)] }.select { |(_, x)| x && x.first }.to_h
        end

        private

        def records_for_class(klass)
          klass.sent_and_undelivered.where(shop_id: shop.id).map &:to_deliverable
        end

        def self.types
          @types ||= Model::Record.sendable.map { |k| [k.plural_name.camelize(:lower), k] }.to_h
        end

      end
    end
  end
end
