class Netfira::WebConnect::RackApp
  module Action::Version8
    class Web < Action

      WEB_BASE = Netfira::WebConnect::ROOT.parent + 'web'
      SEARCH_PATH = [:public, :protected].map { |x| [x, WEB_BASE + x.to_s] }.to_h

      def call
        allow :get
        raise NotFound unless path
        path = self.path.join '/'
        options = SEARCH_PATH.map do |access, dir|
          ['', '.erb'].map do |extension|
            [access, dir.join(path + extension)]
          end
        end.flatten(1).select { |option| option[1].exist? }
        raise NotFound if options.empty?
        raise InternalServerError, "Ambiguous file name (#{options.length} variations)" unless options.length == 1
        send_file options.first.last
      end
    end
  end
end
