module Netfira::WebConnect

  # This class reflects the database's schema
  class Schema < Hash

    def initialize
      classes = Models.constants.map{ |c| Models.const_get c }
      classes.select!{ |klass| klass < Model::Record }
      merge! classes.map{ |klass| [klass, Table.new(klass)] }.to_h
    end

    def as_json(options = nil)
      map do |klass, table|
        [klass.name.demodulize.pluralize, table.as_json(options)]
      end.to_h
    end

  end

end

require_relative 'schema/table'
